import type { AnyObject, Params } from 'pinejs-client-core';
import type * as PineClient from '../typings/pinejs-client-core';
import type { ResourceTypeMap } from './types/models';
interface BackendParams {
    apiUrl: string;
    apiVersion: string;
    apiKey?: string;
    request: {
        send: (options: AnyObject & {
            url: string;
        }) => Promise<{
            body: any;
        }>;
    };
    auth: import('balena-auth').default;
}
export type Pine = PineClient.Pine<ResourceTypeMap>;
/**
 * A variant that makes $select mandatory, helping to create
 * requests that explicitly fetch only what your code needs.
 */
export type PineStrict = PineClient.PineStrict<ResourceTypeMap>;
export declare const createPinejsClient: (params: Params, backendParams: BackendParams) => Pine;
export {};
